diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-ap.py ns-3.41/examples/wireless/wifi-ap.py
--- ns-3.40/examples/wireless/wifi-ap.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-ap.py	2024-02-09 14:44:07.841789700 -0800
@@ -22,7 +22,14 @@
 
 import sys
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 # void
 # DevTxTrace (std::string context, Ptr<const Packet> p, Mac48Address address)
@@ -70,7 +77,8 @@
 #   std::cout << " start="<<start<<" duration="<<duration<<std::endl;
 # }
 
-ns.cppyy.cppdef("""
+ns.cppyy.cppdef(
+    """
     using namespace ns3;
     void AdvancePosition(Ptr<Node> node){
         Ptr<MobilityModel> mob = node->GetObject<MobilityModel>();
@@ -80,7 +88,9 @@
             return;
         mob->SetPosition(pos);
         Simulator::Schedule(Seconds(1.0), AdvancePosition, node);
-    }""")
+    }"""
+)
+
 
 def main(argv):
     ns.core.CommandLine().Parse(argv)
@@ -91,7 +101,7 @@
     mobility = ns.mobility.MobilityHelper()
     stas = ns.network.NodeContainer()
     ap = ns.network.NodeContainer()
-    #NetDeviceContainer staDevs;
+    # NetDeviceContainer staDevs;
     packetSocket = ns.network.PacketSocketHelper()
 
     stas.Create(2)
@@ -109,15 +119,16 @@
     wifiMac = ns.wifi.WifiMacHelper()
 
     # setup stas.
-    wifiMac.SetType("ns3::StaWifiMac",
-                    "ActiveProbing",
-                    ns.core.BooleanValue(True),
-                    "Ssid",
-                    ns.wifi.SsidValue(ssid))
+    wifiMac.SetType(
+        "ns3::StaWifiMac",
+        "ActiveProbing",
+        ns.core.BooleanValue(True),
+        "Ssid",
+        ns.wifi.SsidValue(ssid),
+    )
     staDevs = wifi.Install(wifiPhy, wifiMac, stas)
     # setup ap.
-    wifiMac.SetType("ns3::ApWifiMac",
-                    "Ssid", ns.wifi.SsidValue(ssid))
+    wifiMac.SetType("ns3::ApWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
     wifi.Install(wifiPhy, wifiMac, ap)
 
     # mobility.
@@ -132,7 +143,7 @@
     socket.SetProtocol(1)
 
     onoff = ns.applications.OnOffHelper("ns3::PacketSocketFactory", socket.ConvertTo())
-    onoff.SetConstantRate (ns.network.DataRate ("500kb/s"))
+    onoff.SetConstantRate(ns.network.DataRate("500kb/s"))
 
     apps = onoff.Install(ns.network.NodeContainer(stas.Get(0)))
     apps.Start(ns.core.Seconds(0.5))
@@ -140,13 +151,12 @@
 
     ns.core.Simulator.Stop(ns.core.Seconds(44.0))
 
-  #   Config::Connect("/NodeList/*/DeviceList/*/Tx", MakeCallback(&DevTxTrace));
-  #   Config::Connect("/NodeList/*/DeviceList/*/Rx", MakeCallback(&DevRxTrace));
-  #   Config::Connect("/NodeList/*/DeviceList/*/Phy/RxOk", MakeCallback(&PhyRxOkTrace));
-  #   Config::Connect("/NodeList/*/DeviceList/*/Phy/RxError", MakeCallback(&PhyRxErrorTrace));
-  #   Config::Connect("/NodeList/*/DeviceList/*/Phy/Tx", MakeCallback(&PhyTxTrace));
-  #   Config::Connect("/NodeList/*/DeviceList/*/Phy/State", MakeCallback(&PhyStateTrace));
-
+    #   Config::Connect("/NodeList/*/DeviceList/*/Tx", MakeCallback(&DevTxTrace));
+    #   Config::Connect("/NodeList/*/DeviceList/*/Rx", MakeCallback(&DevRxTrace));
+    #   Config::Connect("/NodeList/*/DeviceList/*/Phy/RxOk", MakeCallback(&PhyRxOkTrace));
+    #   Config::Connect("/NodeList/*/DeviceList/*/Phy/RxError", MakeCallback(&PhyRxErrorTrace));
+    #   Config::Connect("/NodeList/*/DeviceList/*/Phy/Tx", MakeCallback(&PhyTxTrace));
+    #   Config::Connect("/NodeList/*/DeviceList/*/Phy/State", MakeCallback(&PhyStateTrace));
 
     ns.core.Simulator.Run()
     ns.core.Simulator.Destroy()
@@ -154,6 +164,5 @@
     return 0
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     sys.exit(main(sys.argv))
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-backward-compatibility.cc ns-3.41/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.40/examples/wireless/wifi-backward-compatibility.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-backward-compatibility.cc	2024-02-09 14:44:07.841789700 -0800
@@ -30,6 +30,7 @@
 #include "ns3/ssid.h"
 #include "ns3/tuple.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
@@ -149,7 +150,7 @@
     WifiMacHelper mac;
     WifiHelper wifi;
     Ssid ssid = Ssid("ns3");
-    TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue> channelValue;
 
     const auto& [staStandard, staBand] = ConvertStringToStandardAndBand(staVersion);
     wifi.SetStandard(staStandard);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-eht-network.cc ns-3.41/examples/wireless/wifi-eht-network.cc
--- ns-3.40/examples/wireless/wifi-eht-network.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-eht-network.cc	2024-02-09 14:44:07.841789700 -0800
@@ -25,7 +25,6 @@
 #include "ns3/enum.h"
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-address-helper.h"
-#include "ns3/ipv4-global-routing-helper.h"
 #include "ns3/log.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-model-spectrum-channel.h"
@@ -37,6 +36,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/wifi-acknowledgment.h"
 #include "ns3/yans-wifi-channel.h"
@@ -93,7 +93,7 @@
         }
     }
     return rxBytes;
-};
+}
 
 /**
  * Print average throughput over an intermediate time interval.
@@ -146,7 +146,12 @@
     bool udp{true};
     bool downlink{true};
     bool useRts{false};
-    bool useExtendedBlockAck{false};
+    uint16_t mpduBufferSize{512};
+    std::string emlsrLinks;
+    uint16_t paddingDelayUsec{32};
+    uint16_t transitionDelayUsec{128};
+    uint16_t channelSwitchDelayUsec{100};
+    bool switchAuxPhy{true};
     double simulationTime{10}; // seconds
     double distance{1.0};      // meters
     double frequency{5};       // whether the first link operates in the 2.4, 5 or 6 GHz
@@ -181,6 +186,22 @@
         "Whether the third link operates in the 2.4, 5 or 6 GHz band (0 means the device has up to "
         "two links, otherwise the band must be different than first link and second link)",
         frequency3);
+    cmd.AddValue("emlsrLinks",
+                 "The comma separated list of IDs of EMLSR links (for MLDs only)",
+                 emlsrLinks);
+    cmd.AddValue("emlsrPaddingDelay",
+                 "The EMLSR padding delay in microseconds (0, 32, 64, 128 or 256)",
+                 paddingDelayUsec);
+    cmd.AddValue("emlsrTransitionDelay",
+                 "The EMLSR transition delay in microseconds (0, 16, 32, 64, 128 or 256)",
+                 transitionDelayUsec);
+    cmd.AddValue("emlsrAuxSwitch",
+                 "Whether Aux PHY should switch channel to operate on the link on which "
+                 "the Main PHY was operating before moving to the link of the Aux PHY. ",
+                 switchAuxPhy);
+    cmd.AddValue("channelSwitchDelay",
+                 "The PHY channel switch delay in microseconds",
+                 channelSwitchDelayUsec);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -190,7 +211,9 @@
                  "Generate downlink flows if set to 1, uplink flows otherwise",
                  downlink);
     cmd.AddValue("useRts", "Enable/disable RTS/CTS", useRts);
-    cmd.AddValue("useExtendedBlockAck", "Enable/disable use of extended BACK", useExtendedBlockAck);
+    cmd.AddValue("mpduBufferSize",
+                 "Size (in number of MPDUs) of the BlockAck buffer",
+                 mpduBufferSize);
     cmd.AddValue("nStations", "Number of non-AP HE stations", nStations);
     cmd.AddValue("dlAckType",
                  "Ack sequence type for DL OFDMA (NO-OFDMA, ACK-SU-FORMAT, MU-BAR, AGGR-MU-BAR)",
@@ -286,6 +309,7 @@
 
                 wifi.SetStandard(WIFI_STANDARD_80211be);
                 std::array<std::string, 3> channelStr;
+                std::array<FrequencyRange, 3> freqRanges;
                 uint8_t nLinks = 0;
                 std::string dataModeStr = "EhtMcs" + std::to_string(mcs);
                 std::string ctrlRateStr;
@@ -308,6 +332,7 @@
                     if (freq == 6)
                     {
                         channelStr[nLinks] += "BAND_6GHZ, 0}";
+                        freqRanges[nLinks] = WIFI_SPECTRUM_6_GHZ;
                         Config::SetDefault("ns3::LogDistancePropagationLossModel::ReferenceLoss",
                                            DoubleValue(48));
                         wifi.SetRemoteStationManager(nLinks,
@@ -320,6 +345,7 @@
                     else if (freq == 5)
                     {
                         channelStr[nLinks] += "BAND_5GHZ, 0}";
+                        freqRanges[nLinks] = WIFI_SPECTRUM_5_GHZ;
                         ctrlRateStr = "OfdmRate" + std::to_string(nonHtRefRateMbps) + "Mbps";
                         wifi.SetRemoteStationManager(nLinks,
                                                      "ns3::ConstantRateWifiManager",
@@ -331,6 +357,7 @@
                     else if (freq == 2.4)
                     {
                         channelStr[nLinks] += "BAND_2_4GHZ, 0}";
+                        freqRanges[nLinks] = WIFI_SPECTRUM_2_4_GHZ;
                         Config::SetDefault("ns3::LogDistancePropagationLossModel::ReferenceLoss",
                                            DoubleValue(40));
                         ctrlRateStr = "ErpOfdmRate" + std::to_string(nonHtRefRateMbps) + "Mbps";
@@ -349,6 +376,11 @@
                     nLinks++;
                 }
 
+                if (nLinks > 1 && !emlsrLinks.empty())
+                {
+                    wifi.ConfigEhtOptions("EmlsrActivated", BooleanValue(true));
+                }
+
                 Ssid ssid = Ssid("ns3-80211be");
 
                 /*
@@ -357,21 +389,28 @@
                  * and one with 312.5 kHz bands for, e.g., non-HT PPDUs (for more details,
                  * see issue #408 (CLOSED))
                  */
-                Ptr<MultiModelSpectrumChannel> spectrumChannel =
-                    CreateObject<MultiModelSpectrumChannel>();
-
-                Ptr<LogDistancePropagationLossModel> lossModel =
-                    CreateObject<LogDistancePropagationLossModel>();
-                spectrumChannel->AddPropagationLossModel(lossModel);
-
                 SpectrumWifiPhyHelper phy(nLinks);
                 phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
-                phy.SetChannel(spectrumChannel);
+                phy.Set("ChannelSwitchDelay", TimeValue(MicroSeconds(channelSwitchDelayUsec)));
 
                 mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
+                mac.SetEmlsrManager("ns3::DefaultEmlsrManager",
+                                    "EmlsrLinkSet",
+                                    StringValue(emlsrLinks),
+                                    "EmlsrPaddingDelay",
+                                    TimeValue(MicroSeconds(paddingDelayUsec)),
+                                    "EmlsrTransitionDelay",
+                                    TimeValue(MicroSeconds(transitionDelayUsec)),
+                                    "SwitchAuxPhy",
+                                    BooleanValue(switchAuxPhy));
                 for (uint8_t linkId = 0; linkId < nLinks; linkId++)
                 {
                     phy.Set(linkId, "ChannelSettings", StringValue(channelStr[linkId]));
+
+                    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+                    auto lossModel = CreateObject<LogDistancePropagationLossModel>();
+                    spectrumChannel->AddPropagationLossModel(lossModel);
+                    phy.AddChannel(spectrumChannel, freqRanges[linkId]);
                 }
                 staDevices = wifi.Install(phy, mac, wifiStaNodes);
 
@@ -402,9 +441,8 @@
                 Config::Set(
                     "/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HeConfiguration/GuardInterval",
                     TimeValue(NanoSeconds(gi)));
-                Config::Set(
-                    "/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HeConfiguration/MpduBufferSize",
-                    UintegerValue(useExtendedBlockAck ? 256 : 64));
+                Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MpduBufferSize",
+                            UintegerValue(mpduBufferSize));
 
                 // mobility.
                 MobilityHelper mobility;
@@ -507,8 +545,6 @@
                                         simulationTime + 1);
                 }
 
-                Simulator::Schedule(Seconds(0), &Ipv4GlobalRoutingHelper::PopulateRoutingTables);
-
                 Simulator::Stop(Seconds(simulationTime + 1));
                 Simulator::Run();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-he-network.cc ns-3.41/examples/wireless/wifi-he-network.cc
--- ns-3.40/examples/wireless/wifi-he-network.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-he-network.cc	2024-02-09 14:44:07.841789700 -0800
@@ -37,6 +37,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/wifi-acknowledgment.h"
 #include "ns3/yans-wifi-channel.h"
@@ -250,11 +251,8 @@
                                              StringValue(ossDataMode.str()),
                                              "ControlMode",
                                              ctrlRate);
-                // Set guard interval and MPDU buffer size
-                wifi.ConfigHeOptions("GuardInterval",
-                                     TimeValue(NanoSeconds(gi)),
-                                     "MpduBufferSize",
-                                     UintegerValue(useExtendedBlockAck ? 256 : 64));
+                // Set guard interval
+                wifi.ConfigHeOptions("GuardInterval", TimeValue(NanoSeconds(gi)));
 
                 Ssid ssid = Ssid("ns3-80211ax");
 
@@ -277,7 +275,11 @@
                     phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
                     phy.SetChannel(spectrumChannel);
 
-                    mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
+                    mac.SetType("ns3::StaWifiMac",
+                                "Ssid",
+                                SsidValue(ssid),
+                                "MpduBufferSize",
+                                UintegerValue(useExtendedBlockAck ? 256 : 64));
                     phy.Set("ChannelSettings", StringValue(channelStr));
                     staDevices = wifi.Install(phy, mac, wifiStaNodes);
 
@@ -305,7 +307,11 @@
                     phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
                     phy.SetChannel(channel.Create());
 
-                    mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
+                    mac.SetType("ns3::StaWifiMac",
+                                "Ssid",
+                                SsidValue(ssid),
+                                "MpduBufferSize",
+                                UintegerValue(useExtendedBlockAck ? 256 : 64));
                     phy.Set("ChannelSettings", StringValue(channelStr));
                     staDevices = wifi.Install(phy, mac, wifiStaNodes);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-ht-network.cc ns-3.41/examples/wireless/wifi-ht-network.cc
--- ns-3.40/examples/wireless/wifi-ht-network.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/wireless/wifi-ht-network.cc	2024-02-09 14:44:07.841789700 -0800
@@ -36,6 +36,7 @@
 #include "ns3/string.h"
 #include "ns3/tuple.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
@@ -176,7 +177,8 @@
                 wifi.ConfigHtOptions("ShortGuardIntervalSupported", BooleanValue(sgi));
 
                 Ssid ssid = Ssid("ns3-80211n");
-                TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+                TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>
+                    channelValue;
                 WifiPhyBand band = (frequency == 5.0 ? WIFI_PHY_BAND_5GHZ : WIFI_PHY_BAND_2_4GHZ);
                 channelValue.Set(WifiPhy::ChannelTuple{0, channelWidth, band, 0});
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-mixed-network.cc ns-3.41/examples/wireless/wifi-mixed-network.cc
--- ns-3.40/examples/wireless/wifi-mixed-network.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-mixed-network.cc	2024-02-09 14:44:07.845789700 -0800
@@ -32,6 +32,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/yans-wifi-channel.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-multi-tos.cc ns-3.41/examples/wireless/wifi-multi-tos.cc
--- ns-3.40/examples/wireless/wifi-multi-tos.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-multi-tos.cc	2024-02-09 14:44:07.845789700 -0800
@@ -191,7 +191,7 @@
     }
     else
     {
-        NS_LOG_ERROR("Obtained throughput is 0!");
+        std::cout << "Obtained throughput is 0!" << std::endl;
         exit(1);
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-power-adaptation-interference.cc ns-3.41/examples/wireless/wifi-power-adaptation-interference.cc
--- ns-3.40/examples/wireless/wifi-power-adaptation-interference.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-power-adaptation-interference.cc	2024-02-09 14:44:07.845789700 -0800
@@ -670,7 +670,7 @@
     for (auto i = stats.begin(); i != stats.end(); ++i)
     {
         Ipv4FlowClassifier::FiveTuple t = classifier->FindFlow(i->first);
-        if ((t.sourceAddress == "10.1.1.3" && t.destinationAddress == "10.1.1.1"))
+        if (t.sourceAddress == "10.1.1.3" && t.destinationAddress == "10.1.1.1")
         {
             NS_LOG_INFO("Flow " << i->first << " (" << t.sourceAddress << " -> "
                                 << t.destinationAddress << ")\n");
@@ -688,7 +688,7 @@
                         << i->second.jitterSum.GetSeconds() / (i->second.rxPackets - 1) << "\n");
             NS_LOG_INFO("  Tx Opp: " << 1 - (statisticsAp0.GetBusyTime() / simuTime));
         }
-        if ((t.sourceAddress == "10.1.1.4" && t.destinationAddress == "10.1.1.2"))
+        if (t.sourceAddress == "10.1.1.4" && t.destinationAddress == "10.1.1.2")
         {
             NS_LOG_INFO("Flow " << i->first << " (" << t.sourceAddress << " -> "
                                 << t.destinationAddress << ")\n");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-simple-ht-hidden-stations.cc ns-3.41/examples/wireless/wifi-simple-ht-hidden-stations.cc
--- ns-3.40/examples/wireless/wifi-simple-ht-hidden-stations.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-simple-ht-hidden-stations.cc	2024-02-09 14:44:07.845789700 -0800
@@ -25,9 +25,11 @@
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/log.h"
 #include "ns3/mobility-helper.h"
+#include "ns3/rng-seed-manager.h"
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
@@ -63,6 +65,9 @@
     double minExpectedThroughput = 0;
     double maxExpectedThroughput = 0;
 
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(5);
+
     CommandLine cmd(__FILE__);
     cmd.AddValue("nMpdus", "Number of aggregated MPDUs", nMpdus);
     cmd.AddValue("payloadSize", "Payload size in bytes", payloadSize);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-spatial-reuse.cc ns-3.41/examples/wireless/wifi-spatial-reuse.cc
--- ns-3.40/examples/wireless/wifi-spatial-reuse.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-spatial-reuse.cc	2024-02-09 14:44:07.845789700 -0800
@@ -23,7 +23,7 @@
 //
 //  The geometry is as follows:
 //
-//                STA1          STA1
+//                STA1          STA2
 //                 |              |
 //              d1 |              |d2
 //                 |       d3     |
@@ -34,7 +34,7 @@
 //
 //  STA1 is continuously transmitting data to AP1, while STA2 is continuously sending data to AP2.
 //  Each STA has configurable traffic loads (inter packet interval and packet size).
-//  It is also possible to configure TX power per node as well as their CCA-ED tresholds.
+//  It is also possible to configure TX power per node as well as their CCA-ED thresholds.
 //  OBSS_PD spatial reuse feature can be enabled (default) or disabled, and the OBSS_PD
 //  threshold can be set as well (default: -72 dBm).
 //  A simple Friis path loss model is used and a constant PHY rate is considered.
@@ -81,6 +81,9 @@
 //  benefits of spatial reuse in this scenario. This can, for
 //  instance, be accomplished by setting --interval=0.0001.
 //
+//  Spatial reuse reset events are traced in two text files:
+//  - wifi-spatial-reuse-resets-bss-1.txt (for STA 1)
+//  - wifi-spatial-reuse-resets-bss-2.txt (for STA 2)
 
 #include "ns3/abort.h"
 #include "ns3/ap-wifi-mac.h"
@@ -89,8 +92,10 @@
 #include "ns3/config.h"
 #include "ns3/double.h"
 #include "ns3/he-configuration.h"
+#include "ns3/he-phy.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/obss-pd-algorithm.h"
 #include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-helper.h"
 #include "ns3/packet-socket-server.h"
@@ -102,6 +107,8 @@
 using namespace ns3;
 
 std::vector<uint32_t> bytesReceived(4);
+std::ofstream g_resetFile1;
+std::ofstream g_resetFile2;
 
 uint32_t
 ContextToNodeId(std::string context)
@@ -118,6 +125,34 @@
     bytesReceived[nodeId] += p->GetSize();
 }
 
+void
+ResetTrace(std::string context,
+           uint8_t bssColor,
+           double rssiDbm,
+           bool powerRestricted,
+           double txPowerMaxDbmSiso,
+           double txPowerMaxDbmMimo)
+{
+    if (context == "1")
+    {
+        g_resetFile1 << Simulator::Now().GetSeconds() << " bssColor: " << +bssColor
+                     << " rssiDbm: " << rssiDbm << " powerRestricted: " << powerRestricted
+                     << " txPowerMaxDbmSiso: " << txPowerMaxDbmSiso
+                     << " txPowerMaxDbmMimo: " << txPowerMaxDbmMimo << std::endl;
+    }
+    else if (context == "2")
+    {
+        g_resetFile2 << Simulator::Now().GetSeconds() << " bssColor: " << +bssColor
+                     << " rssiDbm: " << rssiDbm << " powerRestricted: " << powerRestricted
+                     << " txPowerMaxDbmSiso: " << txPowerMaxDbmSiso
+                     << " txPowerMaxDbmMimo: " << txPowerMaxDbmMimo << std::endl;
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown context " << context);
+    }
+}
+
 int
 main(int argc, char* argv[])
 {
@@ -164,6 +199,9 @@
     cmd.AddValue("mcs", "The constant MCS value to transmit HE PPDUs", mcs);
     cmd.Parse(argc, argv);
 
+    g_resetFile1.open("wifi-spatial-reuse-resets-bss-1.txt", std::ofstream::out);
+    g_resetFile2.open("wifi-spatial-reuse-resets-bss-2.txt", std::ofstream::out);
+
     NodeContainer wifiStaNodes;
     wifiStaNodes.Create(2);
 
@@ -318,6 +356,18 @@
     Config::Connect("/NodeList/*/ApplicationList/*/$ns3::PacketSocketServer/Rx",
                     MakeCallback(&SocketRx));
 
+    // Obtain pointers to the ObssPdAlgorithm objects and hook trace sinks
+    // to the Reset trace source on each STA.  Note that this trace connection
+    // cannot be done through the Config path system, so pointers are used.
+    auto deviceA = staDeviceA.Get(0)->GetObject<WifiNetDevice>();
+    auto hePhyA = DynamicCast<HePhy>(deviceA->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    // Pass in the context string "1" to allow the trace to distinguish objects
+    hePhyA->GetObssPdAlgorithm()->TraceConnect("Reset", "1", MakeCallback(&ResetTrace));
+    auto deviceB = staDeviceB.Get(0)->GetObject<WifiNetDevice>();
+    auto hePhyB = DynamicCast<HePhy>(deviceB->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    // Pass in the context string "2" to allow the trace to distinguish objects
+    hePhyB->GetObssPdAlgorithm()->TraceConnect("Reset", "2", MakeCallback(&ResetTrace));
+
     Simulator::Stop(Seconds(duration));
     Simulator::Run();
 
@@ -329,5 +379,8 @@
         std::cout << "Throughput for BSS " << i + 1 << ": " << throughput << " Mbit/s" << std::endl;
     }
 
+    g_resetFile1.close();
+    g_resetFile2.close();
+
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-spectrum-per-example.cc ns-3.41/examples/wireless/wifi-spectrum-per-example.cc
--- ns-3.40/examples/wireless/wifi-spectrum-per-example.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-spectrum-per-example.cc	2024-02-09 14:44:07.845789700 -0800
@@ -40,6 +40,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-spectrum-per-interference.cc ns-3.41/examples/wireless/wifi-spectrum-per-interference.cc
--- ns-3.40/examples/wireless/wifi-spectrum-per-interference.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-spectrum-per-interference.cc	2024-02-09 14:44:07.845789700 -0800
@@ -37,6 +37,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/waveform-generator-helper.h"
 #include "ns3/waveform-generator.h"
 #include "ns3/wifi-net-device.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-spectrum-saturation-example.cc ns-3.41/examples/wireless/wifi-spectrum-saturation-example.cc
--- ns-3.40/examples/wireless/wifi-spectrum-saturation-example.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-spectrum-saturation-example.cc	2024-02-09 14:44:07.845789700 -0800
@@ -36,6 +36,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-timing-attributes.cc ns-3.41/examples/wireless/wifi-timing-attributes.cc
--- ns-3.40/examples/wireless/wifi-timing-attributes.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-timing-attributes.cc	2024-02-09 14:44:07.845789700 -0800
@@ -29,6 +29,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-txop-aggregation.cc ns-3.41/examples/wireless/wifi-txop-aggregation.cc
--- ns-3.40/examples/wireless/wifi-txop-aggregation.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-txop-aggregation.cc	2024-02-09 14:44:07.845789700 -0800
@@ -30,6 +30,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/wireless/wifi-vht-network.cc ns-3.41/examples/wireless/wifi-vht-network.cc
--- ns-3.40/examples/wireless/wifi-vht-network.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/examples/wireless/wifi-vht-network.cc	2024-02-09 14:44:07.845789700 -0800
@@ -32,6 +32,7 @@
 #include "ns3/ssid.h"
 #include "ns3/string.h"
 #include "ns3/udp-client-server-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/vht-phy.h"
 #include "ns3/yans-wifi-channel.h"
